Index: debian/README.Debian
===================================================================
--- debian/README.Debian	(revision 94cb84ffc3d6a344edabba7722281fd740e6bde4)
+++ debian/README.Debian	(revision 94cb84ffc3d6a344edabba7722281fd740e6bde4)
@@ -0,0 +1,7 @@
+owl for Debian
+--------------
+
+owl is one of the simpler (while still being extensible) non-graphical
+zephyr clients, which may make it simpler to get started as a user.
+
+ -- Mark W. Eichin <eichin@thok.org>, Tue, 23 Apr 2002 01:58:14 -0400
Index: debian/changelog
===================================================================
--- debian/changelog	(revision 94cb84ffc3d6a344edabba7722281fd740e6bde4)
+++ debian/changelog	(revision 94cb84ffc3d6a344edabba7722281fd740e6bde4)
@@ -0,0 +1,118 @@
+owl (2.1.8-2.1) unstable; urgency=low
+
+  * Non-maintainer upload.
+  * Include a patch from Andreas Jochens to fix compilation with gcc-4.0.
+    Closes: #287891
+  * Add some prototypes to perlglue.xs to avoid the implicit conversion of
+    return pointers from owl_zephyr_get_realm() & owl_zephyr_get_sender().
+    Closes: #326106
+
+ -- dann frazier <dannf@debian.org>  Tue, 11 Oct 2005 20:47:51 -0600
+
+owl (2.1.8-2) unstable; urgency=low
+
+  * zcrypt.c: use kerberosIV/des.h, not the openafs one. Closes: #189108.
+  * configure.in: change it in the test, too.
+
+ -- Mark W. Eichin <eichin@thok.org>  Sun, 29 Aug 2004 16:25:03 -0400
+
+owl (2.1.8-1) unstable; urgency=low
+
+  * New upstream release.  Kept debian/*, dropped all old patches
+    (everything that mattered was already upstream.)
+  * debian/copyright: new upstream location and mailing lists
+  * configure.in: don't look for libdes, it breaks kerberized zephyr.
+  * zephyr.c: actually record error_message in owl_function_error calls.     
+
+ -- Mark W. Eichin <eichin@thok.org>  Sun, 29 Aug 2004 13:21:53 -0400
+
+owl (1.2.9-1.1) unstable; urgency=low
+
+  * NMU
+  * Fix compile error, patch in BTS.  Closes: #189108
+
+ -- LaMont Jones <lamont@debian.org>  Sun,  3 Aug 2003 18:54:07 -0600
+
+owl (1.2.9-1) unstable; urgency=low
+
+  * New upstream release
+  * update fixes resize problem (Closes: #182897)
+  * upstream also took changes for perl multithreading, thanks Bas
+    Zoetekouw and Lamont Jones for the NMU (Closes: #159123)
+	
+ -- Mark W. Eichin <eichin@thok.org>  Sun, 13 Apr 2003 21:04:52 -0400
+
+owl (1.1.3-1.1) unstable; urgency=low
+
+  * NMU
+  * Fix perl 5.8 build problem.  Closes: #159123
+
+ -- LaMont Jones <lamont@debian.org>  Tue,  8 Oct 2002 18:21:44 -0600
+
+owl (1.1.3-1) unstable; urgency=low
+
+  * New upstream release
+
+ -- Mark W. Eichin <eichin@thok.org>  Fri,  5 Jul 2002 14:33:23 -0400
+
+owl (1.0.1-4) unstable; urgency=low
+
+  * debian/control: build-depend on a version of libzephyr late enough to
+    have #110486 fixed.  (Closes: #148404)
+
+ -- Mark W. Eichin <eichin@thok.org>  Thu, 30 May 2002 14:19:18 -0400
+
+owl (1.0.1-3) unstable; urgency=low
+
+  * debian/shlibs.local: override libzephyr3-krb's shlibs file until
+    #148175 is fixed.  (Closes: #148107)
+
+ -- Mark W. Eichin <eichin@thok.org>  Sat, 25 May 2002 18:35:09 -0400
+
+owl (1.0.1-2) unstable; urgency=low
+
+  * update README.debian from pre-release.
+  * configure.in: ditch the explicit krb tests, so we can get the right
+    libs. Crudely done, improvements sought.
+
+ -- Mark W. Eichin <eichin@thok.org>  Sat, 25 May 2002 02:19:47 -0400
+
+owl (1.0.1-1) unstable; urgency=low
+
+  * New upstream release.  Includes the 1.0.1 fixes below.
+  * debian/watch: new file, lets us use uscan and be very lazy :-)
+
+ -- Mark W. Eichin <eichin@thok.org>  Fri, 24 May 2002 17:42:44 -0400
+
+owl (1.0-1) unstable; urgency=low
+
+  * New upstream release (first public deb.) (Closes: #147980)
+  * zephyr.c (loadloginsubs, loadsubs): use free correctly.  (pre-1.0.1 fix)
+  * util.c (owl_free): void, don't return.  (pre-1.0.1 fix)
+
+ -- Mark W. Eichin <eichin@thok.org>  Fri, 24 May 2002 01:27:28 -0400
+
+owl (0.10-1) unstable; urgency=low
+
+  * New upstream release.
+
+ -- Mark W. Eichin <eichin@thok.org>  Tue,  7 May 2002 17:25:28 -0400
+
+owl (0.9-1) unstable; urgency=low
+
+  * New upstream release.
+
+ -- Mark W. Eichin <eichin@thok.org>  Sun, 28 Apr 2002 22:29:02 -0400
+
+owl (0.8.1-1) unstable; urgency=low
+
+  * New upstream release.
+
+ -- Mark W. Eichin <eichin@thok.org>  Wed, 24 Apr 2002 19:19:29 -0400
+
+owl (0.7-1) unstable; urgency=low
+
+  * Initial Release.
+
+ -- Mark W. Eichin <eichin@thok.org>  Tue, 23 Apr 2002 01:58:14 -0400
+
Index: debian/control
===================================================================
--- debian/control	(revision 94cb84ffc3d6a344edabba7722281fd740e6bde4)
+++ debian/control	(revision 94cb84ffc3d6a344edabba7722281fd740e6bde4)
@@ -0,0 +1,15 @@
+Source: owl
+Section: net
+Priority: optional
+Maintainer: Mark W. Eichin <eichin@thok.org>
+Build-Depends: debhelper (>> 3.0.0), libzephyr-dev (>= 2.1.20010518.SNAPSHOT-7), libncurses5-dev, libkrb5-dev, libperl-dev
+Standards-Version: 3.5.2
+
+Package: owl
+Architecture: any
+Depends: ${shlibs:Depends}, zephyr-clients
+Description: A curses-based tty Zephyr client.
+ An alternative standalone (doesn't use zwgc) Zephyr (instant
+ messaging) client.  Has perl hooks and a curses UI.
+ .
+ ktools software -- The 'k' is for Quality!
Index: debian/copyright
===================================================================
--- debian/copyright	(revision 94cb84ffc3d6a344edabba7722281fd740e6bde4)
+++ debian/copyright	(revision 94cb84ffc3d6a344edabba7722281fd740e6bde4)
@@ -0,0 +1,55 @@
+This package was debianized by Mark W. Eichin <eichin@thok.org> on
+Tue, 23 Apr 2002 01:58:14 -0400.
+
+It was downloaded from http://www.ktools.org/dist/owl/owl-2.1.8.tar.gz
+
+Upstream Author(s): bug-ktools@ktools.org
+
+Owl was primarly written by James Kretchmar at the Massachusetts
+Institute of Technology.  Erik Nygren has also made substantial
+contributions and improvemnts to the program.
+
+Copyright:
+
+from owl.c:
+
+/*  Copyright (c) 2004 James Kretchmar. All rights reserved.
+ *
+ *  Redistribution and use in source and binary forms, with or without
+ *  modification, are permitted provided that the following conditions are
+ *  met:
+ *  
+ *    * Redistributions of source code must retain the above copyright
+ *      notice, this list of conditions and the following disclaimer.
+ *  
+ *    * Redistributions in binary form must reproduce the above copyright
+ *      notice, this list of conditions and the following disclaimer in
+ *      the documentation and/or other materials provided with the
+ *      distribution.
+ *  
+ *    * Redistributions in any form must be accompanied by information on
+ *      how to obtain complete source code for the Owl software and any
+ *      accompanying software that uses the Owl software. The source code
+ *      must either be included in the distribution or be available for no
+ *      more than the cost of distribution plus a nominal fee, and must be
+ *      freely redistributable under reasonable conditions. For an
+ *      executable file, complete source code means the source code for
+ *      all modules it contains. It does not include source code for
+ *      modules or files that typically accompany the major components of
+ *      the operating system on which the executable file runs.
+ *  
+ * 
+ *  THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ *  IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
+ *  WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE, OR
+ *  NON-INFRINGEMENT, ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR BE
+ *  LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
+ *  CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
+ *  SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR
+ *  BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
+ *  WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE
+ *  OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN
+ *  IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+  ktools software -- The 'k' is for Quality!
Index: debian/dirs
===================================================================
--- debian/dirs	(revision 94cb84ffc3d6a344edabba7722281fd740e6bde4)
+++ debian/dirs	(revision 94cb84ffc3d6a344edabba7722281fd740e6bde4)
@@ -0,0 +1,1 @@
+usr/bin
Index: debian/rules
===================================================================
--- debian/rules	(revision 94cb84ffc3d6a344edabba7722281fd740e6bde4)
+++ debian/rules	(revision 94cb84ffc3d6a344edabba7722281fd740e6bde4)
@@ -0,0 +1,96 @@
+#!/usr/bin/make -f
+# Sample debian/rules that uses debhelper.
+# GNU copyright 1997 to 1999 by Joey Hess.
+
+# Uncomment this to turn on verbose mode.
+#export DH_VERBOSE=1
+
+# This is the debhelper compatibility version to use.
+export DH_COMPAT=3
+
+# These are used for cross-compiling and for saving the configure script
+# from having to guess our platform (since we know it already)
+DEB_HOST_GNU_TYPE   ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
+DEB_BUILD_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)
+
+
+ifneq (,$(findstring debug,$(DEB_BUILD_OPTIONS)))
+	CFLAGS += -g
+endif
+ifeq (,$(findstring nostrip,$(DEB_BUILD_OPTIONS)))
+	INSTALL_PROGRAM += -s
+endif
+
+config.status: configure
+	dh_testdir
+	# Add here commands to configure the package.
+	./configure --host=$(DEB_HOST_GNU_TYPE) --build=$(DEB_BUILD_GNU_TYPE) --prefix=/usr --mandir=\$${prefix}/share/man --infodir=\$${prefix}/share/info
+
+
+build: build-stamp
+
+build-stamp:  config.status
+	dh_testdir
+
+	# Add here commands to compile the package.
+	$(MAKE)
+	#/usr/bin/docbook-to-man debian/owl.sgml > owl.1
+
+	touch build-stamp
+
+clean:
+	dh_testdir
+	dh_testroot
+	rm -f build-stamp 
+
+	# Add here commands to clean up after the build process.
+	-$(MAKE) distclean
+
+	dh_clean
+
+install: build
+	dh_testdir
+	dh_testroot
+	dh_clean -k
+	dh_installdirs
+
+	# Add here commands to install the package into debian/owl.
+	# $(MAKE) install prefix=$(CURDIR)/debian/owl/usr
+	cp owl $(CURDIR)/debian/owl/usr/bin/
+
+# Build architecture-independent files here.
+binary-indep: build install
+# We have nothing to do by default.
+
+# Build architecture-dependent files here.
+binary-arch: build install
+	dh_testdir
+	dh_testroot
+#	dh_installdebconf	
+	dh_installdocs doc/intro.txt
+	dh_installexamples
+	dh_installmenu
+#	dh_installlogrotate
+#	dh_installemacsen
+#	dh_installpam
+#	dh_installmime
+#	dh_installinit
+	dh_installcron
+	dh_installman doc/owl.1
+	dh_installinfo
+#	dh_undocumented
+	dh_installchangelogs ChangeLog
+	dh_link
+	dh_strip
+	dh_compress
+	dh_fixperms
+#	dh_makeshlibs
+	dh_installdeb
+#	dh_perl
+	dh_shlibdeps
+	dh_gencontrol
+	dh_md5sums
+	dh_builddeb
+
+binary: binary-indep binary-arch
+.PHONY: build clean binary-indep binary-arch binary install 
Index: debian/shlibs.local
===================================================================
--- debian/shlibs.local	(revision 94cb84ffc3d6a344edabba7722281fd740e6bde4)
+++ debian/shlibs.local	(revision 94cb84ffc3d6a344edabba7722281fd740e6bde4)
@@ -0,0 +1,1 @@
+libzephyr 3 libzephyr3