Index: fmtext.c
===================================================================
--- fmtext.c	(revision 765907946990deb3974af5b424314022ebdf86cc)
+++ fmtext.c	(revision 237d02c0b7dc9e5a2f942f7dbcad63b75830350b)
@@ -7,7 +7,4 @@
 {
   f->buff = g_string_new("");
-  f->default_attrs = OWL_FMTEXT_ATTR_NONE;
-  f->default_fgcolor = OWL_COLOR_DEFAULT;
-  f->default_bgcolor = OWL_COLOR_DEFAULT;
 }
 
@@ -17,7 +14,4 @@
 {
   g_string_truncate(f->buff, 0);
-  f->default_attrs = OWL_FMTEXT_ATTR_NONE;
-  f->default_fgcolor = OWL_COLOR_DEFAULT;
-  f->default_bgcolor = OWL_COLOR_DEFAULT;
 }
 
@@ -100,27 +94,4 @@
 }
 
-/* Add the attribute 'attr' to the default atts for the text in 'f' */
-void owl_fmtext_addattr(owl_fmtext *f, char attr)
-{
-  /* add the attribute to all text */
-  f->default_attrs |= attr;
-}
-
-/* Set the default foreground color for this fmtext to 'color'.
- * Only affects text that is colored default.
- */
-void owl_fmtext_colorize(owl_fmtext *f, int color)
-{
-  f->default_fgcolor = color;
-}
-
-/* Set the default foreground color for this fmtext to 'color'.
- * Only affects text that is colored default.
- */
-void owl_fmtext_colorizebg(owl_fmtext *f, int color)
-{
-  f->default_bgcolor = color;
-}
-
 /* Internal function. Parse attrbute character. */
 static void _owl_fmtext_update_attributes(gunichar c, char *attr, short *fgcolor, short *bgcolor)
@@ -235,5 +206,5 @@
  * must already be initiatlized with curses
  */
-static void _owl_fmtext_curs_waddstr(const owl_fmtext *f, WINDOW *w, int do_search)
+static void _owl_fmtext_curs_waddstr(const owl_fmtext *f, WINDOW *w, int do_search, char default_attrs, short default_fgcolor, short default_bgcolor)
 {
   /* char *tmpbuff; */
@@ -250,7 +221,7 @@
   s = f->buff->str;
   /* Set default attributes. */
-  attr = f->default_attrs;
-  fg = f->default_fgcolor;
-  bg = f->default_bgcolor;
+  attr = default_attrs;
+  fg = default_fgcolor;
+  bg = default_bgcolor;
   _owl_fmtext_wattrset(w, attr);
   _owl_fmtext_update_colorpair(fg, bg, &pair);
@@ -295,14 +266,14 @@
       /* Deal with new attributes. Initialize to defaults, then
 	 process all consecutive formatting characters. */
-      attr = f->default_attrs;
-      fg = f->default_fgcolor;
-      bg = f->default_bgcolor;
+      attr = default_attrs;
+      fg = default_fgcolor;
+      bg = default_bgcolor;
       while (owl_fmtext_is_format_char(g_utf8_get_char(p))) {
 	_owl_fmtext_update_attributes(g_utf8_get_char(p), &attr, &fg, &bg);
 	p = g_utf8_next_char(p);
       }
-      _owl_fmtext_wattrset(w, attr | f->default_attrs);
-      if (fg == OWL_COLOR_DEFAULT) fg = f->default_fgcolor;
-      if (bg == OWL_COLOR_DEFAULT) bg = f->default_bgcolor;
+      _owl_fmtext_wattrset(w, attr | default_attrs);
+      if (fg == OWL_COLOR_DEFAULT) fg = default_fgcolor;
+      if (bg == OWL_COLOR_DEFAULT) bg = default_bgcolor;
       _owl_fmtext_update_colorpair(fg, bg, &pair);
       _owl_fmtext_wcolor_set(w, pair);
@@ -322,12 +293,12 @@
 }
 
-void owl_fmtext_curs_waddstr(const owl_fmtext *f, WINDOW *w)
-{
-  _owl_fmtext_curs_waddstr(f, w, 1);
-}
-
-void owl_fmtext_curs_waddstr_without_search(const owl_fmtext *f, WINDOW *w)
-{
-  _owl_fmtext_curs_waddstr(f, w, 0);
+void owl_fmtext_curs_waddstr(const owl_fmtext *f, WINDOW *w, char default_attrs, short default_fgcolor, short default_bgcolor)
+{
+  _owl_fmtext_curs_waddstr(f, w, 1, default_attrs, default_fgcolor, default_bgcolor);
+}
+
+void owl_fmtext_curs_waddstr_without_search(const owl_fmtext *f, WINDOW *w, char default_attrs, short default_fgcolor, short default_bgcolor)
+{
+  _owl_fmtext_curs_waddstr(f, w, 0, default_attrs, default_fgcolor, default_bgcolor);
 }
 
@@ -336,9 +307,4 @@
   int col = start, numcopied = 0;
   char *ptr;
-
-  /* Copy the default attributes. */
-  out->default_attrs = in->default_attrs;
-  out->default_fgcolor = in->default_fgcolor;
-  out->default_bgcolor = in->default_bgcolor;
 
   for (ptr = in->buff->str;
@@ -387,9 +353,4 @@
   /* ptr1 now holds the starting point */
 
-  /* copy the default attributes */
-  out->default_attrs = in->default_attrs;
-  out->default_fgcolor = in->default_fgcolor;
-  out->default_bgcolor = in->default_bgcolor;
-    
   /* copy in the next 'lines' lines */
   if (lines < 1) return(-1);
@@ -415,9 +376,4 @@
   const char *ptr_s, *ptr_e, *ptr_c, *last;
   int col, st, padding, chwidth;
-
-  /* copy the default attributes */
-  out->default_attrs = in->default_attrs;
-  out->default_fgcolor = in->default_fgcolor;
-  out->default_bgcolor = in->default_bgcolor;
 
   last = in->buff->str + in->buff->len - 1;
@@ -588,7 +544,4 @@
 {
   dst->buff = g_string_new(src->buff->str);
-  dst->default_attrs = src->default_attrs;
-  dst->default_fgcolor = src->default_fgcolor;
-  dst->default_bgcolor = src->default_bgcolor;
 }
 