Index: commands.c
===================================================================
--- commands.c	(revision 2fc8397e0117350e37ccc1b1b83ebcc9b94686d2)
+++ commands.c	(revision 435d6b2117710c285d4257eac07f48679613237e)
@@ -916,28 +916,28 @@
 		  "", ""),
 
-  OWLCMD_VOID_CTX("editmulti:move-up-line", owl_editwin_key_up, 
+  OWLCMD_VOID_CTX("edit:move-up-line", owl_editwin_key_up, 
 		  OWL_CTX_EDITMULTI,
 		  "moves the cursor up one line",
 		  "", ""),
 
-  OWLCMD_VOID_CTX("editmulti:move-down-line", owl_editwin_key_down, 
+  OWLCMD_VOID_CTX("edit:move-down-line", owl_editwin_key_down, 
 		  OWL_CTX_EDITMULTI,
 		  "moves the cursor down one line",
 		  "", ""),
 
-  OWLCMD_VOID_CTX("editmulti:done", owl_command_editmulti_done, 
+  OWLCMD_VOID_CTX("edit:done", owl_command_edit_done, 
 		  OWL_CTX_EDITMULTI,
 		  "completes the command (eg, sends message being composed)",
 		  "", ""),
 
-  OWLCMD_VOID_CTX("editmulti:done-or-delete", owl_command_editmulti_done_or_delete, 
+  OWLCMD_VOID_CTX("edit:done-or-delete", owl_command_edit_done_or_delete, 
 		  OWL_CTX_EDITMULTI,
 		  "completes the command, but only if at end of message",
 		  "", 
 		  "If only whitespace is to the right of the cursor,\n"
-		  "runs 'editmulti:done'.\n"\
+		  "runs 'edit:done'.\n"\
 		  "Otherwise runs 'edit:delete-next-char'\n"),
 
-  OWLCMD_VOID_CTX("editmulti:forward-paragraph", owl_editwin_forward_paragraph,
+  OWLCMD_VOID_CTX("edit:forward-paragraph", owl_editwin_forward_paragraph,
                   OWL_CTX_EDITMULTI,
                   "Move forward to end of paragraph.",
@@ -945,5 +945,5 @@
                   "Move the point to the end of the current paragraph"),
 
-  OWLCMD_VOID_CTX("editmulti:backward-paragraph", owl_editwin_backward_paragraph,
+  OWLCMD_VOID_CTX("edit:backward-paragraph", owl_editwin_backward_paragraph,
                   OWL_CTX_EDITMULTI,
                   "Move backward to the start of paragraph.",
@@ -2791,5 +2791,5 @@
 
 
-void owl_command_editmulti_done(owl_editwin *e)
+void owl_command_edit_done(owl_editwin *e)
 {
   owl_history *hist=owl_editwin_get_history(e);
@@ -2806,8 +2806,8 @@
 }
 
-void owl_command_editmulti_done_or_delete(owl_editwin *e)
+void owl_command_edit_done_or_delete(owl_editwin *e)
 {
   if (owl_editwin_is_at_end(e)) {
-    owl_command_editmulti_done(e);
+    owl_command_edit_done(e);
   } else {
     owl_editwin_delete_char(e);
Index: editwin.c
===================================================================
--- editwin.c	(revision 72ab15f8f49554cca076d3ea0271bfe01fce95c0)
+++ editwin.c	(revision 435d6b2117710c285d4257eac07f48679613237e)
@@ -1220,5 +1220,5 @@
   /* XXX force a redisplay? */
   if ((j.ch==13 || j.ch==10) && owl_editwin_check_dotsend(e)) {
-    owl_command_editmulti_done(e);
+    owl_command_edit_done(e);
     return;
   }
Index: keys.c
===================================================================
--- keys.c	(revision 2fc8397e0117350e37ccc1b1b83ebcc9b94686d2)
+++ keys.c	(revision 435d6b2117710c285d4257eac07f48679613237e)
@@ -103,16 +103,16 @@
   owl_keymap_set_submap(km_ew_multi, km_editwin);
 
-  BIND_CMD("UP",      "editmulti:move-up-line", "");
-  BIND_CMD("M-[ A",   "editmulti:move-up-line", "");
-  BIND_CMD("C-p",     "editmulti:move-up-line", "");
-  BIND_CMD("DOWN",    "editmulti:move-down-line", "");
-  BIND_CMD("M-[ B",   "editmulti:move-down-line", "");
-  BIND_CMD("C-n",     "editmulti:move-down-line", "");
-
-  BIND_CMD("M-}",     "editmulti:forward-paragraph", "");
-  BIND_CMD("M-{",     "editmulti:backward-paragraph", "");
+  BIND_CMD("UP",      "edit:move-up-line", "");
+  BIND_CMD("M-[ A",   "edit:move-up-line", "");
+  BIND_CMD("C-p",     "edit:move-up-line", "");
+  BIND_CMD("DOWN",    "edit:move-down-line", "");
+  BIND_CMD("M-[ B",   "edit:move-down-line", "");
+  BIND_CMD("C-n",     "edit:move-down-line", "");
+
+  BIND_CMD("M-}",     "edit:forward-paragraph", "");
+  BIND_CMD("M-{",     "edit:backward-paragraph", "");
 
   /* This would be nice, but interferes with C-c to cancel */
-  /*BIND_CMD("C-c C-c", "editmulti:done", "sends the zephyr");*/
+  /*BIND_CMD("C-c C-c", "edit:done", "sends the zephyr");*/
 
   BIND_CMD("M-p",         "edit:history-prev", "");
@@ -121,5 +121,5 @@
   /* note that changing "disable-ctrl-d" to "on" will change this to 
    * edit:delete-next-char */
-  BIND_CMD("C-d",     "editmulti:done-or-delete", "sends the zephyr if at the end of the message");
+  BIND_CMD("C-d",     "edit:done-or-delete", "sends the zephyr if at the end of the message");
 
 