Index: commands.c
===================================================================
--- commands.c	(revision fd472a72fa087427f33915628b7b8f24e4f17613)
+++ commands.c	(revision 451db9e0515b2671c88e0858f712b53a7fcc5b76)
@@ -51,5 +51,5 @@
 	      "when owl is started and a logout notification is sent when owl\n"
 	      "is exited.  This behavior can be changed with the 'startuplogin'\n"
-	      "and 'shudownlogout' variables.  If a tty is specified for zlog in\n"
+	      "and 'shutdownlogout' variables.  If a tty is specified for zlog in\n"
 	      "then the owl variable 'tty' will be set to that string, causing\n"
 	      "it to be used as the zephyr location tty.\n"),
@@ -194,5 +194,5 @@
 	      "subscribe to a zephyr class, instance, recipient",
 	      "subscribe [-t] <class> [instance [recipient]]",
-	      "Subscribe the specified class and instance.  If the\n"
+	      "Subscribe to the specified class and instance.  If the\n"
 	      "instance or recipient is not listed on the command\n"
 	      "line they default to * (the wildcard recipient).\n"
@@ -265,5 +265,5 @@
 	      "zpunt <instance>",
 	      "The zpunt command will supress message to the specified\n"
-	      "zephyr triplet.  In the second usage messages as supressed\n"
+	      "zephyr triplet.  In the second usage messages are suppressed\n"
 	      "for class MESSAGE and the named instance.\n\n"
 	      "SEE ALSO:  zunpunt, show zpunts\n"),
@@ -273,5 +273,5 @@
 	      "zunpunt <class> <instance> [recipient]\n"
 	      "zunpunt <instance>",
-	      "The zunpunt command will allow messages that were previosly\n"
+	      "The zunpunt command will allow messages that were previously\n"
 	      "suppressed to be received again.\n\n"
 	      "SEE ALSO:  zpunt, show zpunts\n"),
@@ -547,5 +547,5 @@
 	      "    true\n"
 	      "    false\n"
-	      "Spaces must be present before and after parenthesis.  If the\n"
+	      "Spaces must be present before and after parentheses.  If the\n"
 	      "optional color arguments are used they specifies the colors that\n"
 	      "messages matching this filter should be displayed in.\n\n"
@@ -594,10 +594,10 @@
 	      "If the curmsg is a personal message narrow\n"
 	      "   to the conversation with that user.\n"
-	      "If the curmsg is a class message, instance foo, recip *\n"
-	      "   message, narrow to the class, inst.\n"
-	      "If the curmsg is a class message then narrow\n"
+	      "If the curmsg is a <MESSAGE, foo, *>\n"
+	      "   message, narrow to the instance.\n"
+	      "If the curmsg is a class message, narrow\n"
 	      "    to the class.\n"
-	      "If the curmsg is a class message and '-i' is specied\n"
-	      "    then narrow to the class, instance\n"),
+	      "If the curmsg is a class message and '-i' is specified\n"
+	      "    then narrow to the class and instance.\n"),
 
   OWLCMD_ARGS("smartfilter", owl_command_smartfilter, OWL_CTX_INTERACTIVE,
@@ -606,9 +606,9 @@
 	      "If the curmsg is a personal message, the filter is\n"
 	      "   the conversation with that user.\n"
-	      "If the curmsg is a class message, instance foo, recip *\n"
-	      "   message, the filter is the class, inst.\n"
+	      "If the curmsg is a <MESSAGE, foo, *>\n"
+	      "   message, the filter is to that instance.\n"
 	      "If the curmsg is a class message, the filter is that class.\n"
 	      "If the curmsg is a class message and '-i' is specied\n"
-	      "    the filter is that <class,instance> pair\n"),
+	      "    the filter is to that class and instance.\n"),
 
   OWLCMD_ARGS("viewclass", owl_command_viewclass, OWL_CTX_INTERACTIVE,
@@ -676,5 +676,5 @@
 	      "If no message id is specified the current message is marked\n"
 	      "for deletion.  Otherwise the message with the given message\n"
-	      "id is marked for deltion.\n"
+	      "id is marked for deletion.\n"
 	      "If '--no-move' is specified, don't move after deletion.\n"
 	      "If 'trash' is specified, deletes all trash/auto messages\n"
@@ -690,5 +690,5 @@
 	      "If no message id is specified the current message is\n"
 	      "unmarked for deletion.  Otherwise the message with the\n"
-	      "given message id is marked for undeltion.\n"
+	      "given message id is unmarked for deletion.\n"
 	      "If '--no-move' is specified, don't move after deletion.\n"
 	      "If 'view' is specified, undeletes all messages\n"
@@ -729,5 +729,5 @@
 	      "specified string and move the cursor there.  If no string\n"
 	      "argument is supplied then the previous one is used.  By\n"
-	      "default searches are done fowards, if -r is used the search\n"
+	      "default searches are done forwards; if -r is used the search\n"
 	      "is performed backwards"),
 
@@ -738,5 +738,5 @@
           "argument and makes it the default argument for future\n"
           "search commands, but does not move the cursor.  With\n"
-          "no argument, it makes search inactive."),
+          "no argument, it makes search highlighting inactive."),
 
   OWLCMD_ARGS("aimlogin", owl_command_aimlogin, OWL_CTX_ANY,
@@ -2616,5 +2616,5 @@
   cmd = owl_message_get_attribute_value(m, "yescommand");
   if(!cmd) {
-    owl_function_error("No yes command!");
+    owl_function_error("No 'yes' command!");
     return;
   }
@@ -2650,5 +2650,5 @@
   cmd = owl_message_get_attribute_value(m, "nocommand");
   if(!cmd) {
-    owl_function_error("No no command!");
+    owl_function_error("No 'no' command!");
     return;
   }
Index: variable.c
===================================================================
--- variable.c	(revision da466e09b1d178435cf117a103dee8a511df94f2)
+++ variable.c	(revision 451db9e0515b2671c88e0858f712b53a7fcc5b76)
@@ -84,5 +84,5 @@
 
   OWLVAR_BOOL( "sepbar_disable" /* %OwlVarStub */, 0,
-	       "disable printing information in the seperator bar", "" ),
+	       "disable printing information in the separator bar", "" ),
 
   OWLVAR_BOOL( "smartstrip" /* %OwlVarStub */, 1,
@@ -142,5 +142,5 @@
 		    "location of users in your .anyone file.  If a user is present\n"
 		    "but sent no login message, or a user is not present that sent no\n"
-		    "logout message a pseudo login or logout message wil be created\n",
+		    "logout message, a pseudo login or logout message wil be created\n",
 		    NULL, owl_variable_pseudologins_set, NULL),
 
Index: zephyr.c
===================================================================
--- zephyr.c	(revision ddacb9c3329f737df1696a687fea4b7df8d46871)
+++ zephyr.c	(revision 451db9e0515b2671c88e0858f712b53a7fcc5b76)
@@ -806,5 +806,5 @@
   if (numlocs==0) {
     myuser=short_zuser(user);
-    sprintf(out, "%s: Hidden or not logged-in\n", myuser);
+    sprintf(out, "%s: Hidden or not logged in\n", myuser);
     owl_free(myuser);
     return;