Index: keymap.c
===================================================================
--- keymap.c	(revision f87c490cdfe78c49dc11396ee2f43689f278e13a)
+++ keymap.c	(revision cf83b7a15ef998b48ca0aa69dae69a963b365dc1)
@@ -5,5 +5,6 @@
 
 /* returns 0 on success */
-int owl_keymap_init(owl_keymap *km, char *name, char *desc, void (*default_fn)(int), void (*prealways_fn)(int), void (*postalways_fn)(int)) {
+int owl_keymap_init(owl_keymap *km, char *name, char *desc, void (*default_fn)(int), void (*prealways_fn)(int), void (*postalways_fn)(int))
+{
   if (!name || !desc) return(-1);
   if ((km->name = owl_strdup(name)) == NULL) return(-1);
@@ -18,5 +19,6 @@
 
 /* note that this will free the memory for the bindings! */
-void owl_keymap_free(owl_keymap *km) {
+void owl_keymap_free(owl_keymap *km)
+{
   owl_free(km->name);
   owl_free(km->desc);
@@ -24,10 +26,12 @@
 }
 
-void owl_keymap_set_submap(owl_keymap *km, owl_keymap *submap) {
+void owl_keymap_set_submap(owl_keymap *km, owl_keymap *submap)
+{
   km->submap = submap;
 }
 
 /* creates and adds a key binding */
-int owl_keymap_create_binding(owl_keymap *km, char *keyseq, char *command, void (*function_fn)(void), char *desc) {
+int owl_keymap_create_binding(owl_keymap *km, char *keyseq, char *command, void (*function_fn)(void), char *desc)
+{
   owl_keybinding *kb, *curkb;
   int i;
@@ -52,5 +56,6 @@
 
 /* returns a summary line describing this keymap.  the caller must free. */
-char *owl_keymap_summary(owl_keymap *km) {
+char *owl_keymap_summary(owl_keymap *km)
+{
   char *s;
   int slen;
@@ -63,5 +68,6 @@
 
 /* Appends details about the keymap to fm */
-void owl_keymap_get_details(owl_keymap *km, owl_fmtext *fm) {
+void owl_keymap_get_details(owl_keymap *km, owl_fmtext *fm)
+{
   int i, nbindings; 
   owl_keybinding *kb;
@@ -131,5 +137,6 @@
 /* NOTE: keyhandler has private access to the internals of keymap */
 
-int owl_keyhandler_init(owl_keyhandler *kh) {
+int owl_keyhandler_init(owl_keyhandler *kh)
+{
   if (0 != owl_dict_create(&kh->keymaps)) return(-1); 
   kh->active = NULL;
@@ -139,9 +146,11 @@
 
 /* adds a new keymap */
-void owl_keyhandler_add_keymap(owl_keyhandler *kh, owl_keymap *km) {
+void owl_keyhandler_add_keymap(owl_keyhandler *kh, owl_keymap *km)
+{
   owl_dict_insert_element(&kh->keymaps, km->name, km, NULL);
 }
 
-owl_keymap *owl_keyhandler_create_and_add_keymap(owl_keyhandler *kh, char *name, char *desc, void (*default_fn)(int), void (*prealways_fn)(int), void (*postalways_fn)(int)) {
+owl_keymap *owl_keyhandler_create_and_add_keymap(owl_keyhandler *kh, char *name, char *desc, void (*default_fn)(int), void (*prealways_fn)(int), void (*postalways_fn)(int))
+{
   owl_keymap *km;
   km = (owl_keymap*)owl_malloc(sizeof(owl_keymap));
@@ -153,5 +162,6 @@
 
 /* resets state and clears out key stack */
-void owl_keyhandler_reset(owl_keyhandler *kh) {
+void owl_keyhandler_reset(owl_keyhandler *kh)
+{
   kh->in_esc = 0;
   memset(kh->kpstack, 0, (OWL_KEYMAP_MAXSTACK+1)*sizeof(int));
@@ -159,14 +169,17 @@
 }
 
-owl_keymap *owl_keyhandler_get_keymap(owl_keyhandler *kh, char *mapname) {
+owl_keymap *owl_keyhandler_get_keymap(owl_keyhandler *kh, char *mapname)
+{
   return (owl_keymap*)owl_dict_find_element(&kh->keymaps, mapname);
 }
 
 /* free the list with owl_cmddict_namelist_free */
-void owl_keyhandler_get_keymap_names(owl_keyhandler *kh, owl_list *l) {
+void owl_keyhandler_get_keymap_names(owl_keyhandler *kh, owl_list *l)
+{
   owl_dict_get_keys(&kh->keymaps, l);
 }
 
-void owl_keyhandler_keymap_namelist_free(owl_list *l) {
+void owl_keyhandler_keymap_namelist_free(owl_list *l)
+{
   owl_list_free_all(l, owl_free);
 }
@@ -176,5 +189,6 @@
 /* sets the active keymap, which will also reset any key state.
  * returns the new keymap, or NULL on failure. */
-owl_keymap *owl_keyhandler_activate(owl_keyhandler *kh, char *mapname) {
+owl_keymap *owl_keyhandler_activate(owl_keyhandler *kh, char *mapname)
+{
   owl_keymap *km;
   if (kh->active && !strcmp(mapname, kh->active->name)) return(kh->active);
@@ -188,5 +202,6 @@
 /* processes a keypress.  returns 0 if the keypress was handled,
  * 1 if not handled, -1 on error, and -2 if j==ERR. */
-int owl_keyhandler_process(owl_keyhandler *kh, int j) {
+int owl_keyhandler_process(owl_keyhandler *kh, int j)
+{
   owl_keymap     *km;
   owl_keybinding *kb;
@@ -272,5 +287,6 @@
 }
 
-void owl_keyhandler_invalidkey(owl_keyhandler *kh) {
+void owl_keyhandler_invalidkey(owl_keyhandler *kh)
+{
     char kbbuff[500];
     owl_keybinding_stack_tostring(kh->kpstack, kbbuff, 500);